########################################### Fibonacci #####################################
def fibonacciRec (n):
    if n == 0 or n == 1:
        return n
    else:
        return fibonacciRec(n-1) + fibonacciRec(n-2)

def fibonacciProgDynAscendant(n):
    tableau = [0] * (n + 1)
    tableau[1] = 1
    for i in range(2, n + 1):
        tableau[i] = tableau[i - 1] + tableau[i - 2]
    return tableau[n]

def fibonacciProgDynDescendant(n):
    tableau = [None] * (n+1)
    return fibonacciProgDynDescendantRec(n,tableau)

def fibonacciProgDynDescendantRec(n,tableau):
    if tableau[n]:
        return tableau[n]
    if n == 0 or n == 1:
        tableau[n] = n
    else:
        tableau[n] = fibonacciProgDynDescendantRec(n-1,tableau) + fibonacciProgDynDescendantRec(n-2,tableau)
    return tableau[n]

def fibonacciRecPlus(n, last = True):
    if n == 0:
        res = (0, 0)
    elif n == 1:
        res = (0, 1)
    else:
        fib1, fib2 = fibonacciRecPlus(n - 1, False)
        res = (fib2, fib1 + fib2)
    if last:
        return res[1]
    else:
        return res 

'''
print("Terme 10 de la suite de Fibonacci (recursif) : ",str(fibonacciRec(10)))
print("Terme 10 de la suite de Fibonacci (prog dyn ascend) : ",str(fibonacciProgDynAscendant(10)))
print("Terme 10 de la suite de Fibonacci (prog dyn descend) : ",str(fibonacciProgDynDescendant(10)))
print("Terme 10 de la suite de Fibonacci (prog dyn descend) : ",str(fibonacciRecPlus(10)))
'''

################################## Rendu de monnaie #####################################
systemeMonetaire = [1,2,5,10,20,50,100,200]

def renduMonnaieGlouton(montant) :
    return renduMonnaieGloutonRecur(montant, [], len(systemeMonetaire)-1)

def renduMonnaieGloutonRecur(montant,rendu,indPiece) :
    if montant == 0 :
        return rendu
    while montant >= systemeMonetaire[indPiece]:
        montant -= systemeMonetaire[indPiece]
        rendu.append(systemeMonetaire[indPiece])
    return renduMonnaieGloutonRecur(montant, rendu, indPiece - 1)

def creerTableauPiecesMin(montant):
    n = len(systemeMonetaire)  # n = nombre de pièces différentes
    # init à infini matrice de taille montant (de 0 à montant par pas de 1) par n (nombre de pièces différentes)
    pieces_min = [[float('inf')] * (montant + 1) for _ in range(n)]
    for sousMontant in range(montant + 1): # pour tout sous-montant inférieur à montant
        if sousMontant % systemeMonetaire[0] == 0: # si plus petite pièce diviseur du sous-montant
            pieces_min[0][sousMontant] = sousMontant // systemeMonetaire[0] # alors on peut atteindre le sous-montant avec ces petites pieces
    for i in range(1, n):   # on parcours le reste des lignes (pièces)
        for j in range(montant + 1):       # on parcours toutes les colonnes (sous-montants)
            pieces_min[i][j] = pieces_min[i - 1][j] # la solution avec des plus petites pièces est aussi une solution avec une plus grosse
            if systemeMonetaire[i] <= j:    # si la valeur de la piece est plus petite que le sous-montant (ie. on peut utiliser la pièce)
                if pieces_min[i][j - systemeMonetaire[i]] + 1 < pieces_min[i][j]:  # si utiliser la pièce i permet de rendre moins de pièces que la solution précédente
                    pieces_min[i][j] = pieces_min[i][j - systemeMonetaire[i]] + 1  # alors on l'utilise
    return pieces_min

def renduMonnaieProgDyn(montant):
    pieces_min = creerTableauPiecesMin(montant)
    #print(pieces_min)
    n = len(systemeMonetaire)
    # pieces_min[n][montant] contient le nombre minimal de pièces rendues pour le montant
    # avec des pièces de valeur inférieure ou égal à la pièce d'indice n
    # retourner la taille de pieces_min retournerait le nombre minimal de pièces de rendu
    # mais on cherche à aussi récupérer la valeur de chaque pièce rendue
    rendu = []  # la liste des pièces à rendre
    i = n - 1      # i sert à parcourir les lignes du tableau (pièces), de plus grosse à la plus petite
    while montant > 0:   # on aura fini lorsque l'on aura atteint un montant nul à rendre
        if montant >= systemeMonetaire[i]:   # si la pièce i est utilisable
            if pieces_min[i][montant - systemeMonetaire[i]] + 1 == pieces_min[i][montant]: # si la pièce i est optimale
                rendu.append(systemeMonetaire[i]) # on ajoute la pièce i à la solution
                montant -= systemeMonetaire[i]  # on décrémente le montant
                continue # on peut passer à la résolution du nouveau montant
        i -= 1  # on ne peut pas utiliser la pièce i (trop grosse ou pas optimale), on passe à la suivante (plus petite)
    return rendu

import PileFile as pf

def renduMonnaieProgDynArbre(montant):
    deja_calcule = [False] * montant # pour garder trace des montants déjà calculés
    file = pf.File([(montant, [])])  # la file du parcours en largeur de l'arbre
    while not file.estVide() : # tant que pas tout exploré
        (valeur, liste_pieces) = file.traiter() # on traite le premier de file
        for piece in systemeMonetaire:  # on calcule les n fils de ce noeud
            if valeur == piece:              # si on a trouvé la dernière pièce qui donne une nouvelle valeur à rendre de 0
                liste_pieces.append(piece) # on ajoute la pièce à la solution
                return liste_pieces  # on retourne la solution
            if valeur - piece > 0 and not deja_calcule[valeur - piece]: # pas encore fini (nouvelle valeur positive et pas déjà calculée)
                liste_pieces_tmp = liste_pieces.copy()  # copie de la liste pour autoriser les changements futurs sur cette liste
                liste_pieces_tmp.append(piece) # on ajoute la pièce à la solution et on continue
                file.enfiler((valeur - piece, liste_pieces_tmp)) # on ajoute dans la file pour parcourir en largeur
                deja_calcule[valeur - piece] = True # on indique qu'on est passé par cette valeur
    print("Rendu impossible") # si on arrive là c'est que le rendu n'est pas possible avec ce système monétaire

'''
print("Rendu glouton sur 263 : ",end='')
print(renduMonnaieGlouton(263))
print("Rendu prog dyn sur 263 : ",end='')
print(renduMonnaieProgDyn(263))
print("Rendu prog dyn arbre sur 263 : ",end='')
print(renduMonnaieProgDynArbre(263))

systemeMonetaire = [1,3,4]

print("Rendu glouton sur 6 : ",end='')
print(renduMonnaieGlouton(6))
print("Rendu prog dyn sur 6 : ",end='')
print(renduMonnaieProgDyn(6))
print("Rendu prog dyn arbre sur 6 : ",end='')
print(renduMonnaieProgDynArbre(6))
'''

################################## Sac a dos #####################################
objets = [['A',6,5], ['B',3,2], ['C',3,2], ['D',3,2], ['E',1,1]]

def sacADosGlouton(W) :
    poidsActuel = 0
    solution = []
    for i in range(len(objets)) :
        if poidsActuel + objets[i][2] <= W:
            poidsActuel += objets[i][2]
            solution.append(objets[i][0])
    return solution

def max_valeur(W):
    max_val = [[0]*(W+1) for _ in range(len(objets)+1)]         # init du tableau des valeurs a 0
    optimal  = [[False]*(W+1) for _ in range(len(objets)+1)]    # init du tableau des booleens a False
    for i in range(1,len(objets)+1):  # on parcourt/ajoute les objets un à un
        for w in range(W+1):    # on calcule l'optimal pour toutes les capacités possibles
            if objets[i-1][2] > w:     # si l'objet est plus lourd que la capacité (on ne peut pas le prendre)
                max_val[i][w] = max_val[i-1][w]   # on a la même valeur que sans l'objet
            else:   # si on peut prendre l'objet
                if objets[i-1][1] + max_val[i-1][w - objets[i-1][2]] > max_val[i-1][w]:
                    # si la somme de sa valeur avec la valeur optimale sans l'objet et son poids est plus grande
                    # que la valeur optimale sans l'objet mais avec son poids, alors on doit garder l'objet
                    max_val[i][w] = objets[i-1][1] + max_val[i-1][w-objets[i-1][2]]
                    optimal[i][w] = True
                else:
                    # sinon on ne garde pas l'objet, la valeur est la même que sans l'objet
                    max_val[i][w] = max_val[i-1][w]
    return optimal

def sacADosProgDyn(W):
    optimal = max_valeur(W)
    # on parcourt le tableau optimal et on construit l'ensemble des objets optimaux
    objets_optimaux = []
    for i in range(len(objets),0,-1):   # on parcourt le tableau du bas vers le haut
        if optimal[i][W]:     # si l'objet est optimal pour la capacité courante
            objets_optimaux.append(objets[i-1][0])   # on l'ajoute à la solution
            W -= objets[i-1][2]   # on diminue la capacité du poids de l'objet
        # en passant à la prochaine itération (i-1) on ne considère plus l'objet i
    return objets_optimaux

'''
print("Les objets selectionnes sont (glouton) : ",end='')
print(sacADosGlouton(6))

print("Les objets selectionnes sont (prog dyn) : ",end='')
print(sacADosProgDyn(6))
'''